Makefile 19 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536
  1. ifndef VERBOSE
  2. .SILENT:
  3. endif
  4. # Never run this makefile in parallel, as it could screw things up
  5. # It won't affect the submakes, so you still get the speedup from specifying -jx
  6. .NOTPARALLEL:
  7. # Allow the silent with lower caps to work the same way as upper caps
  8. ifdef silent
  9. SILENT = $(silent)
  10. endif
  11. ifdef SILENT
  12. SUB_IS_SILENT := $(SILENT)
  13. endif
  14. # We need to make sure that silent is always turned off at the top level
  15. # Otherwise the [OK], [ERROR] and [WARN] messages won't be displayed correctly
  16. override SILENT := false
  17. ifndef SUB_IS_SILENT
  18. ifndef SKIP_GIT
  19. QMK_VERSION := $(shell git describe --abbrev=0 --tags 2>/dev/null)
  20. endif
  21. ifneq ($(QMK_VERSION),)
  22. $(info QMK Firmware $(QMK_VERSION))
  23. endif
  24. endif
  25. # Determine which qmk cli to use
  26. QMK_BIN := qmk
  27. # avoid 'Entering|Leaving directory' messages
  28. MAKEFLAGS += --no-print-directory
  29. ON_ERROR := error_occurred=1
  30. BREAK_ON_ERRORS = no
  31. STARTING_MAKEFILE := $(firstword $(MAKEFILE_LIST))
  32. ROOT_MAKEFILE := $(lastword $(MAKEFILE_LIST))
  33. ROOT_DIR := $(dir $(ROOT_MAKEFILE))
  34. ifeq ($(ROOT_DIR),)
  35. ROOT_DIR := .
  36. endif
  37. ABS_STARTING_MAKEFILE := $(abspath $(STARTING_MAKEFILE))
  38. ABS_ROOT_MAKEFILE := $(abspath $(ROOT_MAKEFILE))
  39. ABS_STARTING_DIR := $(dir $(ABS_STARTING_MAKEFILE))
  40. ABS_ROOT_DIR := $(dir $(ABS_ROOT_MAKEFILE))
  41. STARTING_DIR := $(subst $(ABS_ROOT_DIR),,$(ABS_STARTING_DIR))
  42. BUILD_DIR := $(ROOT_DIR)/.build
  43. TEST_DIR := $(BUILD_DIR)/test
  44. ERROR_FILE := $(BUILD_DIR)/error_occurred
  45. MAKEFILE_INCLUDED=yes
  46. # Helper function to process the newt element of a space separated path
  47. # It works a bit like the traditional functional head tail
  48. # so the CURRENT_PATH_ELEMENT will become the new head
  49. # and the PATH_ELEMENTS are the rest that are still unprocessed
  50. define NEXT_PATH_ELEMENT
  51. $$(eval CURRENT_PATH_ELEMENT := $$(firstword $$(PATH_ELEMENTS)))
  52. $$(eval PATH_ELEMENTS := $$(wordlist 2,9999,$$(PATH_ELEMENTS)))
  53. endef
  54. # We change the / to spaces so that we more easily can work with the elements
  55. # separately
  56. PATH_ELEMENTS := $(subst /, ,$(STARTING_DIR))
  57. # Initialize the path elements list for further processing
  58. $(eval $(call NEXT_PATH_ELEMENT))
  59. # Phony targets to enable a few simple make commands outside the main processing below.
  60. .PHONY: list-keyboards
  61. list-keyboards:
  62. util/list_keyboards.sh | sort -u | tr '\n' ' '
  63. .PHONY: generate-keyboards-file
  64. generate-keyboards-file:
  65. util/list_keyboards.sh | sort -u
  66. .PHONY: clean
  67. clean:
  68. echo -n 'Deleting .build/ ... '
  69. rm -rf $(BUILD_DIR)
  70. echo 'done.'
  71. .PHONY: distclean
  72. distclean: clean
  73. echo -n 'Deleting *.bin, *.hex, and *.uf2 ... '
  74. rm -f *.bin *.hex *.uf2
  75. echo 'done.'
  76. #Compatibility with the old make variables, anything you specify directly on the command line
  77. # always overrides the detected folders
  78. ifdef keyboard
  79. KEYBOARD := $(keyboard)
  80. endif
  81. ifdef keymap
  82. KEYMAP := $(keymap)
  83. endif
  84. # Uncomment these for debugging
  85. # $(info Keyboard: $(KEYBOARD))
  86. # $(info Keymap: $(KEYMAP))
  87. # Set the default goal depending on where we are running make from
  88. # this handles the case where you run make without any arguments
  89. .DEFAULT_GOAL := all:all
  90. ifneq ($(KEYMAP),)
  91. .DEFAULT_GOAL := $(KEYBOARD):$(KEYMAP)
  92. else ifneq ($(KEYBOARD),)
  93. # Inside a keyboard folder, build all keymaps for all subprojects
  94. # Note that this is different from the old behaviour, which would
  95. # build only the default keymap of the default keyboard
  96. .DEFAULT_GOAL := $(KEYBOARD):all
  97. endif
  98. # Compare the start of the RULE variable with the first argument($1)
  99. # If the rules equals $1 or starts with $1:, RULE_FOUND is set to true
  100. # and $1 is removed from the RULE variable
  101. # Otherwise the RULE_FOUND variable is set to false, and RULE left as it was
  102. # The function is a bit tricky, since there's no built in $(startswith) function
  103. define COMPARE_AND_REMOVE_FROM_RULE_HELPER
  104. ifeq ($1,$$(RULE))
  105. RULE:=
  106. RULE_FOUND := true
  107. else
  108. STARTCOLON_REMOVED=$$(subst START$1:,,START$$(RULE))
  109. ifneq ($$(STARTCOLON_REMOVED),START$$(RULE))
  110. RULE_FOUND := true
  111. RULE := $$(STARTCOLON_REMOVED)
  112. else
  113. RULE_FOUND := false
  114. endif
  115. endif
  116. endef
  117. # This makes it easier to call COMPARE_AND_REMOVE_FROM_RULE, since it makes it behave like
  118. # a function that returns the value
  119. COMPARE_AND_REMOVE_FROM_RULE = $(eval $(call COMPARE_AND_REMOVE_FROM_RULE_HELPER,$1))$(RULE_FOUND)
  120. # Recursively try to find a match for the start of the rule to be checked
  121. # $1 The list to be checked
  122. # If a match is found, then RULE_FOUND is set to true
  123. # and MATCHED_ITEM to the item that was matched
  124. define TRY_TO_MATCH_RULE_FROM_LIST_HELPER3
  125. ifneq ($1,)
  126. ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,$$(firstword $1)),true)
  127. MATCHED_ITEM := $$(firstword $1)
  128. else
  129. $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$$(wordlist 2,9999,$1)))
  130. endif
  131. endif
  132. endef
  133. # A recursive helper function for finding the longest match
  134. # $1 The list to be checked
  135. # It works by always removing the currently matched item from the list
  136. define TRY_TO_MATCH_RULE_FROM_LIST_HELPER2
  137. # Stop the recursion when the list is empty
  138. ifneq ($1,)
  139. RULE_BEFORE := $$(RULE)
  140. $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$1))
  141. # If a match is found in the current list, otherwise just return what we had before
  142. ifeq ($$(RULE_FOUND),true)
  143. # Save the best match so far and call itself recursively
  144. BEST_MATCH := $$(MATCHED_ITEM)
  145. BEST_MATCH_RULE := $$(RULE)
  146. RULE_FOUND := false
  147. RULE := $$(RULE_BEFORE)
  148. $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$$(filter-out $$(MATCHED_ITEM),$1)))
  149. endif
  150. endif
  151. endef
  152. # Recursively try to find the longest match for the start of the rule to be checked
  153. # $1 The list to be checked
  154. # If a match is found, then RULE_FOUND is set to true
  155. # and MATCHED_ITEM to the item that was matched
  156. define TRY_TO_MATCH_RULE_FROM_LIST_HELPER
  157. BEST_MATCH :=
  158. $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$1))
  159. ifneq ($$(BEST_MATCH),)
  160. RULE_FOUND := true
  161. RULE := $$(BEST_MATCH_RULE)
  162. MATCHED_ITEM := $$(BEST_MATCH)
  163. else
  164. RULE_FOUND := false
  165. MATCHED_ITEM :=
  166. endif
  167. endef
  168. # Make it easier to call TRY_TO_MATCH_RULE_FROM_LIST
  169. TRY_TO_MATCH_RULE_FROM_LIST = $(eval $(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER,$1))$(RULE_FOUND)
  170. define ALL_IN_LIST_LOOP
  171. OLD_RULE$1 := $$(RULE)
  172. $$(eval $$(call $1,$$(ITEM$1)))
  173. RULE := $$(OLD_RULE$1)
  174. endef
  175. define PARSE_ALL_IN_LIST
  176. $$(foreach ITEM$1,$2,$$(eval $$(call ALL_IN_LIST_LOOP,$1)))
  177. endef
  178. # The entry point for rule parsing
  179. # parses a rule in the format <keyboard>:<keymap>:<target>
  180. # but this particular function only deals with the first <keyboard> part
  181. define PARSE_RULE
  182. RULE := $1
  183. COMMANDS :=
  184. REQUIRE_PLATFORM_KEY :=
  185. # If the rule starts with all, then continue the parsing from
  186. # PARSE_ALL_KEYBOARDS
  187. ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
  188. KEYBOARD_RULE=all
  189. $$(eval $$(call PARSE_ALL_KEYBOARDS))
  190. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all-avr),true)
  191. KEYBOARD_RULE=all
  192. REQUIRE_PLATFORM_KEY := avr
  193. $$(eval $$(call PARSE_ALL_KEYBOARDS))
  194. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all-chibios),true)
  195. KEYBOARD_RULE=all
  196. REQUIRE_PLATFORM_KEY := chibios
  197. $$(eval $$(call PARSE_ALL_KEYBOARDS))
  198. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all-arm_atsam),true)
  199. KEYBOARD_RULE=all
  200. REQUIRE_PLATFORM_KEY := arm_atsam
  201. $$(eval $$(call PARSE_ALL_KEYBOARDS))
  202. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,test),true)
  203. $$(eval $$(call PARSE_TEST))
  204. # If the rule starts with the name of a known keyboard, then continue
  205. # the parsing from PARSE_KEYBOARD
  206. else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(shell util/list_keyboards.sh | sort -u)),true)
  207. KEYBOARD_RULE=$$(MATCHED_ITEM)
  208. $$(eval $$(call PARSE_KEYBOARD,$$(MATCHED_ITEM)))
  209. # Otherwise use the KEYBOARD variable, which is determined either by
  210. # the current directory you run make from, or passed in as an argument
  211. else ifneq ($$(KEYBOARD),)
  212. $$(eval $$(call PARSE_KEYBOARD,$$(KEYBOARD)))
  213. else
  214. $$(info make: *** No rule to make target '$1'. Stop.)
  215. $$(info |)
  216. $$(info | QMK's make format is:)
  217. $$(info | make keyboard_folder:keymap_folder[:target])
  218. $$(info |)
  219. $$(info | Where `keyboard_folder` is the path to the keyboard relative to)
  220. $$(info | `qmk_firmware/keyboards/`, and `keymap_folder` is the name of the)
  221. $$(info | keymap folder under that board's `keymaps/` directory.)
  222. $$(info |)
  223. $$(info | Examples:)
  224. $$(info | keyboards/dz60, keyboards/dz60/keymaps/default)
  225. $$(info | -> make dz60:default)
  226. $$(info | -> qmk compile -kb dz60 -km default)
  227. $$(info | keyboards/planck/rev6, keyboards/planck/keymaps/default)
  228. $$(info | -> make planck/rev6:default:flash)
  229. $$(info | -> qmk flash -kb planck/rev6 -km default)
  230. $$(info |)
  231. endif
  232. endef
  233. # $1 = Keyboard
  234. # Parses a rule in the format <keymap>:<target>
  235. # the keyboard is already known when entering this function
  236. define PARSE_KEYBOARD
  237. # If we want to compile the default subproject, then we need to
  238. # include the correct makefile to determine the actual name of it
  239. CURRENT_KB := $1
  240. # KEYBOARD_FOLDERS := $$(subst /, , $(CURRENT_KB))
  241. DEFAULT_FOLDER := $$(CURRENT_KB)
  242. # We assume that every rules.mk will contain the full default value
  243. $$(eval include $(ROOT_DIR)/keyboards/$$(CURRENT_KB)/rules.mk)
  244. ifneq ($$(DEFAULT_FOLDER),$$(CURRENT_KB))
  245. $$(eval include $(ROOT_DIR)/keyboards/$$(DEFAULT_FOLDER)/rules.mk)
  246. endif
  247. CURRENT_KB := $$(DEFAULT_FOLDER)
  248. # 5/4/3/2/1
  249. KEYBOARD_FOLDER_PATH_1 := $$(CURRENT_KB)
  250. KEYBOARD_FOLDER_PATH_2 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_1)))
  251. KEYBOARD_FOLDER_PATH_3 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_2)))
  252. KEYBOARD_FOLDER_PATH_4 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_3)))
  253. KEYBOARD_FOLDER_PATH_5 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_4)))
  254. KEYMAPS :=
  255. # get a list of all keymaps
  256. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/keymaps/*/.)))
  257. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/keymaps/*/.)))
  258. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/keymaps/*/.)))
  259. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/keymaps/*/.)))
  260. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/keymaps/*/.)))
  261. KEYBOARD_LAYOUTS := $(shell $(QMK_BIN) list-layouts --keyboard $1)
  262. LAYOUT_KEYMAPS :=
  263. $$(foreach LAYOUT,$$(KEYBOARD_LAYOUTS),$$(eval LAYOUT_KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/layouts/*/$$(LAYOUT)/*/.)))))
  264. KEYMAPS := $$(sort $$(KEYMAPS) $$(LAYOUT_KEYMAPS))
  265. # if the rule after removing the start of it is empty (we haven't specified a kemap or target)
  266. # compile all the keymaps
  267. ifeq ($$(RULE),)
  268. $$(eval $$(call PARSE_ALL_KEYMAPS))
  269. # The same if all was specified
  270. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
  271. $$(eval $$(call PARSE_ALL_KEYMAPS))
  272. # List all keymaps for the given keyboard
  273. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,list-keymaps),true)
  274. $$(eval $$(call LIST_ALL_KEYMAPS))
  275. # Try to match the specified keyamp with the list of known keymaps
  276. else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYMAPS)),true)
  277. $$(eval $$(call PARSE_KEYMAP,$$(MATCHED_ITEM)))
  278. # Otherwise try to match the keymap from the current folder, or arguments to the make command
  279. else ifneq ($$(KEYMAP),)
  280. $$(eval $$(call PARSE_KEYMAP,$$(KEYMAP)))
  281. # Otherwise if we are running make all:<user> just skip
  282. else ifeq ($$(KEYBOARD_RULE),all)
  283. # $$(info Skipping: No user keymap for $$(CURRENT_KB))
  284. # Otherwise, make all keymaps, again this is consistent with how it works without
  285. # any arguments
  286. else
  287. $$(eval $$(call PARSE_ALL_KEYMAPS))
  288. endif
  289. endef
  290. # if we are going to compile all keyboards, match the rest of the rule
  291. # for each of them
  292. define PARSE_ALL_KEYBOARDS
  293. $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYBOARD,$(shell util/list_keyboards.sh noci | sort -u)))
  294. endef
  295. # Prints a list of all known keymaps for the given keyboard
  296. define LIST_ALL_KEYMAPS
  297. COMMAND_true_LIST_KEYMAPS := \
  298. printf "$$(KEYMAPS)\n";
  299. COMMAND_false_LIST_KEYMAPS := \
  300. printf "$$(MSG_AVAILABLE_KEYMAPS)\n"; \
  301. printf "$$(KEYMAPS)\n";
  302. COMMANDS += LIST_KEYMAPS
  303. endef
  304. # $1 Keymap
  305. # This is the meat of compiling a keyboard, when entering this, everything is known
  306. # keyboard, subproject, and keymap
  307. # Note that we are not directly calling the command here, but instead building a list,
  308. # which will later be processed
  309. define PARSE_KEYMAP
  310. CURRENT_KM = $1
  311. # The rest of the rule is the target
  312. # Remove the leading ":" from the target, as it acts as a separator
  313. MAKE_TARGET := $$(patsubst :%,%,$$(RULE))
  314. # We need to generate an unique indentifer to append to the COMMANDS list
  315. CURRENT_KB_UNDER := $$(subst /,_,$$(CURRENT_KB))
  316. COMMAND := COMMAND_KEYBOARD_$$(CURRENT_KB_UNDER)_KEYMAP_$$(CURRENT_KM)
  317. # If we are compiling a keyboard without a subproject, we want to display just the name
  318. # of the keyboard, otherwise keyboard/subproject
  319. KB_SP := $$(CURRENT_KB)
  320. # Format it in bold
  321. KB_SP := $(BOLD)$$(KB_SP)$(NO_COLOR)
  322. # Specify the variables that we are passing forward to submake
  323. MAKE_VARS := KEYBOARD=$$(CURRENT_KB) KEYMAP=$$(CURRENT_KM) REQUIRE_PLATFORM_KEY=$$(REQUIRE_PLATFORM_KEY) QMK_BIN=$$(QMK_BIN)
  324. # And the first part of the make command
  325. MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_keyboard.mk $$(MAKE_TARGET)
  326. # The message to display
  327. MAKE_MSG := $$(MSG_MAKE_KB)
  328. # We run the command differently, depending on if we want more output or not
  329. # The true version for silent output and the false version otherwise
  330. $$(eval $$(call BUILD))
  331. endef
  332. define BUILD
  333. MAKE_VARS += VERBOSE=$(VERBOSE) COLOR=$(COLOR)
  334. COMMANDS += $$(COMMAND)
  335. COMMAND_true_$$(COMMAND) := \
  336. printf "$$(MAKE_MSG)" | \
  337. $$(MAKE_MSG_FORMAT); \
  338. LOG=$$$$($$(MAKE_CMD) $$(MAKE_VARS) SILENT=true 2>&1) ; \
  339. if [ $$$$? -gt 0 ]; \
  340. then $$(PRINT_ERROR_PLAIN); \
  341. elif [ "$$$$LOG" = "skipped" ] ; \
  342. then $$(PRINT_SKIPPED_PLAIN); \
  343. elif [ "$$$$LOG" != "" ] ; \
  344. then $$(PRINT_WARNING_PLAIN); \
  345. else \
  346. $$(PRINT_OK); \
  347. fi;
  348. COMMAND_false_$$(COMMAND) := \
  349. printf "$$(MAKE_MSG)\n\n"; \
  350. $$(MAKE_CMD) $$(MAKE_VARS) SILENT=false; \
  351. if [ $$$$? -gt 0 ]; \
  352. then error_occurred=1; \
  353. fi;
  354. endef
  355. # Just parse all the keymaps for a specific keyboard
  356. define PARSE_ALL_KEYMAPS
  357. $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYMAP,$$(KEYMAPS)))
  358. endef
  359. define BUILD_TEST
  360. TEST_NAME := $1
  361. MAKE_TARGET := $2
  362. COMMAND := $1
  363. MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_test.mk $$(MAKE_TARGET)
  364. MAKE_VARS := TEST=$$(TEST_NAME) FULL_TESTS="$$(FULL_TESTS)"
  365. MAKE_MSG := $$(MSG_MAKE_TEST)
  366. $$(eval $$(call BUILD))
  367. ifneq ($$(MAKE_TARGET),clean)
  368. TEST_EXECUTABLE := $$(TEST_DIR)/$$(TEST_NAME).elf
  369. TESTS += $$(TEST_NAME)
  370. TEST_MSG := $$(MSG_TEST)
  371. $$(TEST_NAME)_COMMAND := \
  372. printf "$$(TEST_MSG)\n"; \
  373. $$(TEST_EXECUTABLE); \
  374. if [ $$$$? -gt 0 ]; \
  375. then error_occurred=1; \
  376. fi; \
  377. printf "\n";
  378. endif
  379. endef
  380. define PARSE_TEST
  381. TESTS :=
  382. TEST_NAME := $$(firstword $$(subst :, ,$$(RULE)))
  383. TEST_TARGET := $$(subst $$(TEST_NAME),,$$(subst $$(TEST_NAME):,,$$(RULE)))
  384. ifeq ($$(TEST_NAME),all)
  385. MATCHED_TESTS := $$(TEST_LIST)
  386. else
  387. MATCHED_TESTS := $$(foreach TEST,$$(TEST_LIST),$$(if $$(findstring $$(TEST_NAME),$$(TEST)),$$(TEST),))
  388. endif
  389. $$(foreach TEST,$$(MATCHED_TESTS),$$(eval $$(call BUILD_TEST,$$(TEST),$$(TEST_TARGET))))
  390. endef
  391. # Set the silent mode depending on if we are trying to compile multiple keyboards or not
  392. # By default it's on in that case, but it can be overridden by specifying silent=false
  393. # from the command line
  394. define SET_SILENT_MODE
  395. ifdef SUB_IS_SILENT
  396. SILENT_MODE := $(SUB_IS_SILENT)
  397. else ifeq ($$(words $$(COMMANDS)),1)
  398. SILENT_MODE := false
  399. else
  400. SILENT_MODE := true
  401. endif
  402. endef
  403. include $(ROOT_DIR)/message.mk
  404. ifeq ($(strip $(BREAK_ON_ERRORS)), yes)
  405. HANDLE_ERROR = exit 1
  406. else
  407. HANDLE_ERROR = echo $$error_occurred > $(ERROR_FILE)
  408. endif
  409. # The empty line is important here, as it will force a new shell to be created for each command
  410. # Otherwise the command line will become too long with a lot of keyboards and keymaps
  411. define RUN_COMMAND
  412. +error_occurred=0;\
  413. $(COMMAND_$(SILENT_MODE)_$(COMMAND))\
  414. if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
  415. endef
  416. define RUN_TEST
  417. +error_occurred=0;\
  418. $($(TEST)_COMMAND)\
  419. if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
  420. endef
  421. # Catch everything and parse the command line ourselves.
  422. .PHONY: %
  423. %:
  424. # Check if we have the CMP tool installed
  425. cmp $(ROOT_DIR)/Makefile $(ROOT_DIR)/Makefile >/dev/null 2>&1; if [ $$? -gt 0 ]; then printf "$(MSG_NO_CMP)"; exit 1; fi;
  426. # Ensure that $(QMK_BIN) works.
  427. if ! $(QMK_BIN) hello 1> /dev/null 2>&1; then printf "$(MSG_PYTHON_MISSING)"; exit 1; fi
  428. # Check if the submodules are dirty, and display a warning if they are
  429. ifndef SKIP_GIT
  430. if [ ! -e lib/chibios ]; then git submodule sync lib/chibios && git submodule update --depth 50 --init lib/chibios; fi
  431. if [ ! -e lib/chibios-contrib ]; then git submodule sync lib/chibios-contrib && git submodule update --depth 50 --init lib/chibios-contrib; fi
  432. if [ ! -e lib/lufa ]; then git submodule sync lib/lufa && git submodule update --depth 50 --init lib/lufa; fi
  433. if [ ! -e lib/vusb ]; then git submodule sync lib/vusb && git submodule update --depth 50 --init lib/vusb; fi
  434. if [ ! -e lib/printf ]; then git submodule sync lib/printf && git submodule update --depth 50 --init lib/printf; fi
  435. git submodule status --recursive 2>/dev/null | \
  436. while IFS= read -r x; do \
  437. case "$$x" in \
  438. \ *) ;; \
  439. *) printf "$(MSG_SUBMODULE_DIRTY)";break;; \
  440. esac \
  441. done
  442. endif
  443. rm -f $(ERROR_FILE) > /dev/null 2>&1
  444. $(eval $(call PARSE_RULE,$@))
  445. $(eval $(call SET_SILENT_MODE))
  446. # Run all the commands in the same shell, notice the + at the first line
  447. # it has to be there to allow parallel execution of the submake
  448. # This always tries to compile everything, even if error occurs in the middle
  449. # But we return the error code at the end, to trigger travis failures
  450. # The sort at this point is to remove duplicates
  451. $(foreach COMMAND,$(sort $(COMMANDS)),$(RUN_COMMAND))
  452. if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
  453. $(foreach TEST,$(sort $(TESTS)),$(RUN_TEST))
  454. if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
  455. lib/%:
  456. git submodule sync $?
  457. git submodule update --init $?
  458. .PHONY: git-submodule
  459. git-submodule:
  460. git submodule sync --recursive
  461. git submodule update --init --recursive --progress
  462. # Generate the version.h file
  463. ifdef SKIP_GIT
  464. VERSION_H_FLAGS := --skip-git
  465. endif
  466. ifdef SKIP_VERSION
  467. VERSION_H_FLAGS := --skip-all
  468. SKIP_GIT := yes
  469. endif
  470. $(shell $(QMK_BIN) generate-version-h $(VERSION_H_FLAGS) -q -o quantum/version.h)
  471. include $(ROOT_DIR)/testlist.mk